"""
https://www.geeksforgeeks.org/number-theory-interesting-facts-and-algorithms/
# 1 Factors
- Composite number
- Highly composite number
- Even and odd numbers
- Parity
- Divisor, aliquot part
- Greatest common divisor
- Least common multiple
- Euclidean algorithm
- Coprime
- Euclid's lemma
- Bézout's identity, Bézout's lemma
- Extended Euclidean algorithm
- Table of divisors
- Prime number, prime power
- Bonse's inequality
- Prime factor
- Table of prime factors
- Formula for primes
- Factorization
- RSA number
- Fundamental theorem of arithmetic
- Square-free
- Square-free integer
- Square-free polynomial
- Square number
- Power of two
- Integer-valued polynomial

# 2 Fractions
- Rational number
- Unit fraction
- Irreducible fraction = in lowest terms
- Dyadic fraction
- Recurring decimal
- Cyclic number
- Farey sequence
- Ford circle
- Stern–Brocot tree
- Dedekind sum
- Egyptian fraction

# 3 Modular arithmetic

- Montgomery reduction
- Modular exponentiation
- Linear congruence theorem
- Method of successive substitution
- Chinese remainder theorem
- Fermat's little theorem
- Proofs of Fermat's little theorem
- Fermat quotient
- Euler's totient function
- Noncototient
- Nontotient
- Euler's theorem
- Wilson's theorem
- Primitive root modulo n
- Multiplicative order
- Discrete logarithm
- Quadratic residue
- Euler's criterion
- Legendre symbol
- Gauss's lemma (number theory)
- Congruence of squares
- Luhn formula
- Mod n cryptanalysis


# 4 Arithmetic functions


- Multiplicative function
- Additive function
- Dirichlet convolution
- Erdős–Kac theorem
- Möbius function
- Möbius inversion formula
- Divisor function
- Liouville function
- Partition function (number theory)
- Integer partition
- Bell numbers
- Landau's function
- Pentagonal number theorem
- Bell series
- Lambert series


# 5 Analytic number theory: additive problems


- Twin prime
- Brun's constant
- Cousin prime
- Prime quadruplet
- Sexy prime
- Sophie Germain prime
- Cunningham chain
- Goldbach's conjecture
- Goldbach's weak conjecture
- Second Hardy–Littlewood conjecture
- Hardy–Littlewood circle method
- Schinzel's hypothesis H
- Bateman–Horn conjecture
- Waring's problem
- Brahmagupta–Fibonacci identity
- Euler's four-square identity
- Lagrange's four-square theorem
- Taxicab number
- Generalized taxicab number
- Cabtaxi number
- Schnirelmann density
- Sumset
- Landau–Ramanujan constant
- Sierpinski number
- Seventeen or Bust
- Niven's constant


# 6 Algebraic number theory


# 7 Quadratic forms



# 8 L-functions

- Riemann zeta function
- Basel problem on ζ(2)
- Hurwitz zeta function
- Bernoulli number
- Agoh–Giuga conjecture
- Von Staudt–Clausen theorem
- Dirichlet series
- Euler product
- Prime number theorem
- Prime-counting function
- Offset logarithmic integral
- Legendre's constant
- Skewes' number
- Bertrand's postulate
- Proof of Bertrand's postulate
- Proof that the sum of the reciprocals of the primes diverges
- Cramér's conjecture
- Riemann hypothesis
- Critical line theorem
- Hilbert–Pólya conjecture
- Generalized Riemann hypothesis
- Mertens function, Mertens conjecture, Meissel–Mertens constant
- De Bruijn–Newman constant
- Dirichlet character
- Dirichlet L-series
- Siegel zero
- Dirichlet's theorem on arithmetic progressions
- Linnik's theorem
- Elliott–Halberstam conjecture
- Functional equation (L-function)
- Chebotarev's density theorem
- Local zeta function
- Weil conjectures
- Modular form
- modular group
- Congruence subgroup
- Hecke operator
- Cusp form
- Eisenstein series
- Modular curve
- Ramanujan–Petersson conjecture
- Birch and Swinnerton-Dyer conjecture
- Automorphic form
- Selberg trace formula
- Artin conjecture
- Sato–Tate conjecture
- Langlands program
- modularity theorem


# 9 Diophantine equations

Pythagorean triple
Pell's equation
Elliptic curve
Nagell–Lutz theorem
Mordell–Weil theorem
Mazur's torsion theorem
Congruent number
Arithmetic of abelian varieties
Elliptic divisibility sequences
Fermat's Last Theorem
Mordell conjecture
Euler's sum of powers conjecture
abc Conjecture
Catalan's conjecture
Pillai's conjecture
Hasse principle
Diophantine set
Matiyasevich's theorem
One thousand seven hundred and twenty nine


# 10 Diophantine approximation


Davenport–Schmidt theorem
Irrational number
Square root of two
Quadratic irrational
Integer square root
Algebraic number
Pisot–Vijayaraghavan number
Salem number
Transcendental number
e (mathematical constant)
pi, list of topics related to pi
Squaring the circle
Proof that e is irrational
Lindemann–Weierstrass theorem
Hilbert's seventh problem
Gelfond–Schneider theorem
Erdős–Borwein constant
Liouville number
Continued fraction
Mathematical constant (sorted by continued fraction representation)
Khinchin's constant
Lévy's constant
Lochs' theorem
Gauss–Kuzmin–Wirsing operator
Minkowski's question mark function
Generalized continued fraction
Kronecker's theorem
Thue–Siegel–Roth theorem
Prouhet–Thue–Morse constant
Gelfond–Schneider constant
Equidistribution mod 1
Beatty's theorem
Littlewood conjecture
Discrepancy function
Low-discrepancy sequence
Illustration of a low-discrepancy sequence
Constructions of low-discrepancy sequences
Halton sequences
Geometry of numbers
Minkowski's theorem
Pick's theorem
Mahler's compactness theorem
Mahler measure
Effective results in number theory
Mahler's theorem





# 11 Sieve methods

Large sieve


# 12 Named primes
Chen prime
Cullen prime
Fermat prime
Sophie Germain prime, safe prime
Mersenne prime
New Mersenne conjecture
Great Internet Mersenne Prime Search
Newman–Shanks–Williams prime
Primorial prime
Wagstaff prime
Wall–Sun–Sun prime
Wieferich prime
Wilson prime
Wolstenholme prime
Woodall prime
Prime pages

# 13 Combinatorial number theory
Covering system
Small set (combinatorics)
Erdős–Ginzburg–Ziv theorem
Polynomial method
Van der Waerden's theorem
Szemerédi's theorem
Collatz conjecture
Gilbreath's conjecture
Erdős–Graham conjecture
Znám's problem

# 14 Computational number theory


# 14.1 Primality tests


# 14.2 Integer factorization


# 14.3 Pseudo-random numbers


# 15 History

"""

from ._basic import*
from .constant_series import*
from .numbthy import*
from .ntheory import*